----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:03:44 06/26/2015 
-- Design Name: 
-- Module Name:    MPA_wrapper - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use work.ipbus.all;
use work.fmc_package.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity MPA_wrapper is
    Port ( clk125 : in  STD_LOGIC;
           beam_clk : in  STD_LOGIC;
           beam_data : in  STD_LOGIC;
           reset : in  STD_LOGIC;
					 fmc1_clk1_M2C_p : in	 std_logic;
					 fmc1_clk1_M2C_n : in	 std_logic;	
					 fmc1_io_pin : inout fmc_io_pin_type;
           ipb_clk : in  STD_LOGIC;
					 ipb_miso_o : out ipb_rbus;
					 ipb_mosi_i : in ipb_wbus;
           LED : out  STD_LOGIC_VECTOR(1 downto 0)
					 );
end MPA_wrapper;

architecture Behavioral of MPA_wrapper is
COMPONENT MPA_top
	PORT(
		clk125 : IN std_logic;
		beam_clk : IN std_logic;
		beam_data : IN std_logic;
		hitOR_p : IN std_logic;
		hitOR_n : IN std_logic;
		conf_din_p : IN std_logic_vector(1 downto 0);
		conf_din_n : IN std_logic_vector(1 downto 0);
		read_din_p : IN std_logic_vector(1 downto 0);
		read_din_n : IN std_logic_vector(1 downto 0);
		mem_p : IN std_logic_vector(11 downto 0);
		mem_n : IN std_logic_vector(11 downto 0);
		util_din_p : IN std_logic;
		util_din_n : IN std_logic;
		ipb_clk : IN std_logic;
		ipb_write : IN std_logic;
		ipb_strobe : IN std_logic;
		ipb_addr : IN std_logic_vector(15 downto 0);
		ipb_wdata : IN std_logic_vector(31 downto 0);          
		led : OUT std_logic_vector(1 to 2);
		shutter_p : OUT std_logic;
		shutter_n : OUT std_logic;
		calstrobe_p : OUT std_logic;
		calstrobe_n : OUT std_logic;
		conf_en_p : OUT std_logic;
		conf_en_n : OUT std_logic;
		conf_clk_p : OUT std_logic;
		conf_clk_n : OUT std_logic;
		conf_dout_p : OUT std_logic_vector(1 downto 0);
		conf_dout_n : OUT std_logic_vector(1 downto 0);
		read_clk_p : OUT std_logic;
		read_clk_n : OUT std_logic;
		read_dout_p : OUT std_logic_vector(1 downto 0);
		read_dout_n : OUT std_logic_vector(1 downto 0);
		enutil_p : OUT std_logic;
		enutil_n : OUT std_logic;
		util_clk_p : OUT std_logic;
		util_clk_n : OUT std_logic;
		util_dout_p : OUT std_logic;
		util_dout_n : OUT std_logic;
		clk160_p : OUT std_logic;
		clk160_n : OUT std_logic;
		ipb_rdata : OUT std_logic_vector(31 downto 0);
		ipb_ack : OUT std_logic
		);
END COMPONENT;
signal mem_p : std_logic_vector(11 downto 0) := (others =>'0');
signal mem_n : std_logic_vector(11 downto 0) := (others =>'0');
signal conf_din_p : std_logic_vector(1 downto 0) := (others =>'0');
signal conf_din_n : std_logic_vector(1 downto 0) := (others =>'0');
signal conf_dout_p : std_logic_vector(1 downto 0) := (others =>'0');
signal conf_dout_n : std_logic_vector(1 downto 0) := (others =>'0');
signal read_din_p : std_logic_vector(1 downto 0) := (others =>'0');
signal read_din_n : std_logic_vector(1 downto 0) := (others =>'0');
signal read_dout_p : std_logic_vector(1 downto 0) := (others =>'0');
signal read_dout_n : std_logic_vector(1 downto 0) := (others =>'0');

begin
fmc1_io_pin.la_p(10) <= '1'; -- FPGA_PWR_ON
mem_p(0) <= fmc1_io_pin.hb_p(15);
mem_n(0) <= fmc1_io_pin.hb_n(15);
mem_p(1) <= fmc1_io_pin.hb_p(14);
mem_n(1) <= fmc1_io_pin.hb_n(14);
mem_p(2) <= fmc1_io_pin.hb_p(11);
mem_n(2) <= fmc1_io_pin.hb_n(11);
mem_p(3) <= fmc1_io_pin.hb_p(17);
mem_n(3) <= fmc1_io_pin.hb_n(17);
mem_p(4) <= fmc1_io_pin.hb_p(18);
mem_n(4) <= fmc1_io_pin.hb_n(18);
mem_p(5) <= fmc1_io_pin.la_p(30);
mem_n(5) <= fmc1_io_pin.la_n(30);
mem_p(6) <= fmc1_io_pin.la_p(14);
mem_n(6) <= fmc1_io_pin.la_n(14);
mem_p(7) <= fmc1_io_pin.ha_p(3);
mem_n(7) <= fmc1_io_pin.ha_n(3);
mem_p(8) <= fmc1_io_pin.la_p(2);
mem_n(8) <= fmc1_io_pin.la_n(2);
mem_p(9) <= fmc1_io_pin.la_p(6);
mem_n(9) <= fmc1_io_pin.la_n(6);
mem_p(10) <= fmc1_io_pin.la_p(1);
mem_n(10) <= fmc1_io_pin.la_n(1);
mem_p(11) <= fmc1_io_pin.ha_p(0);
mem_n(11) <= fmc1_io_pin.ha_n(0);
--conf_din_p(0) <= fmc1_io_pin.la_p(32);
--conf_din_n(0) <= fmc1_io_pin.la_n(32);
conf_din_p(0) <= fmc1_io_pin.hb_p(10);
conf_din_n(0) <= fmc1_io_pin.hb_n(10);
conf_din_p(1) <= fmc1_io_pin.la_p(0);
conf_din_n(1) <= fmc1_io_pin.la_n(0);
--read_din_p(0) <= fmc1_io_pin.hb_p(10);
--read_din_n(0) <= fmc1_io_pin.hb_n(10);
read_din_p(0) <= fmc1_io_pin.la_p(32);
read_din_n(0) <= fmc1_io_pin.la_n(32);
read_din_p(1) <= fmc1_io_pin.ha_p(1);
read_din_n(1) <= fmc1_io_pin.ha_n(1);
fmc1_io_pin.ha_p(6) <= conf_dout_p(0);
fmc1_io_pin.ha_n(6) <= conf_dout_n(0);
fmc1_io_pin.ha_p(2) <= conf_dout_p(1);
fmc1_io_pin.ha_n(2) <= conf_dout_n(1);
fmc1_io_pin.hb_p(20) <= read_dout_p(0);
fmc1_io_pin.hb_n(20) <= read_dout_n(0);
fmc1_io_pin.la_p(33) <= read_dout_p(1);
fmc1_io_pin.la_n(33) <= read_dout_n(1);
i_MPA_top: MPA_top PORT MAP(
		clk125 => clk125,
		beam_clk => beam_clk,
		beam_data => beam_data,
		led => LED,
		hitOR_p => fmc1_io_pin.hb_p(0),
		hitOR_n => fmc1_io_pin.hb_n(0),
		shutter_p => fmc1_io_pin.hb_p(21),
		shutter_n => fmc1_io_pin.hb_n(21),
		calstrobe_p => fmc1_io_pin.ha_p(17),
		calstrobe_n => fmc1_io_pin.ha_n(17),
		conf_en_p => fmc1_io_pin.ha_p(21),
		conf_en_n => fmc1_io_pin.ha_n(21),
		conf_clk_p => fmc1_io_pin.ha_p(10),
		conf_clk_n => fmc1_io_pin.ha_n(10),
		conf_din_p => conf_din_p,
		conf_din_n => conf_din_n,
		conf_dout_p => conf_dout_p,
		conf_dout_n => conf_dout_n,
		read_clk_p => fmc1_io_pin.hb_p(16),
		read_clk_n => fmc1_io_pin.hb_n(16),
		read_din_p => read_din_p,
		read_din_n => read_din_n,
		read_dout_p => read_dout_p,
		read_dout_n => read_dout_n,
		mem_p => mem_p,
		mem_n => mem_n,
		enutil_p => fmc1_io_pin.hb_p(6),
		enutil_n => fmc1_io_pin.hb_n(6),
		util_clk_p => fmc1_io_pin.ha_p(23),
		util_clk_n => fmc1_io_pin.ha_n(23),
		util_din_p => fmc1_io_pin.hb_p(7),
		util_din_n => fmc1_io_pin.hb_n(7),
		util_dout_p => fmc1_io_pin.hb_p(1),
		util_dout_n => fmc1_io_pin.hb_n(1),
		clk160_p => fmc1_io_pin.la_p(20),
		clk160_n => fmc1_io_pin.la_n(20),
		ipb_clk => ipb_clk,
		ipb_write => ipb_mosi_i.ipb_write,
		ipb_strobe => ipb_mosi_i.ipb_strobe,
		ipb_addr => ipb_mosi_i.ipb_addr(15 downto 0),
		ipb_wdata => ipb_mosi_i.ipb_wdata,
		ipb_rdata => ipb_miso_o.ipb_rdata,
		ipb_ack => ipb_miso_o.ipb_ack
	);


end Behavioral;

